/*
 *  MailCheck (WWWC̃vOC)
 *
 *  misc.c
 *
 *  Writen by Masaru Tsuchiyama <tsuchiyama@asahi-net.email.ne.jp>
 */
#include <windows.h>
#include "wwwcdll.h"
#include "Pop3.h"

void *Malloc(int size)
{
    return GlobalAlloc(GPTR,size);
}

void *ReMalloc(void *p,int size)
{
    char *buf = Malloc(size);
    if(buf){
        CopyMemory(buf,p,lstrlen(p) + 1);
    }
    return buf;
}

void Free(void *buf)
{
    GlobalFree((HGLOBAL)buf);
}

char *GetServNameFromCheckURL(char *szURL)
{
    char *p;
    p = szURL;
    if(strnicmp(p,"pop://",sizeof("pop://")-1)==0){
        p += sizeof("pop://")-1;
    }
    return p;
}

char * DupStr(char *buf)
{
    char *p;

    if(buf){
        p = Malloc(lstrlen(buf) + 1);
        if(p){
            lstrcpy(p,buf);
            return p;
        }
    }
    return NULL;
}


char * GetDlgEditText(HWND hDlg,int nID)
{
    char *buf = NULL;
    int bufsize = SendDlgItemMessage(hDlg,nID,WM_GETTEXTLENGTH,0,0);
    if(bufsize > 0){
        buf = Malloc(bufsize + 1);
        if(buf){
            GetDlgItemText(hDlg,nID,buf,bufsize + 1);
        }
    }
    return buf;
}

void RemoveArgs(char *buf)
{
    char *p = buf;
    if(buf == NULL){
        return;
    }
    for(;*p && *p == ' ';p++);
    if(*p == '"'){
        p++;
        for(;*p && *p != '"';p++);
        for(;*p && *p != ' ';p++);
        if(*p){
            *p = '\0';
        }
    }
    else{
        for(;*p && *p != ' ';p++);
        if(*p){
            *p = '\0';
        }
    }
}

char * GetArgs(char *buf)
{
    char *p = buf;
    if(buf == NULL){
        return NULL;
    }
    if(*p == '"'){
        p++;
        for(;*p && *p != '"';p++);
        for(;*p && *p != ' ';p++);
        if(*p){
            return p+1;
        }
    }
    else{
        for(;*p && *p != ' ';p++);
        if(*p){
            return p+1;
        }
    }
    return NULL;
}

/*
 * WWWCԂꂽo[W͂
 * œnꂽύX܂B
 */
unsigned long ParseWWWCVersion(char *szVersion)
{
	char *p,*q;
	int major_version,sub_version;
	int minor_version,beta_version;

	q = szVersion;
	for(p = szVersion; *p != '\0' && *p != '.';p++);
	if(*p == '\0'){
		return 0;
	}
	*p = '\0';
	major_version = atoi(q);

	p++;
	for(q = p; *p != '\0' && *p != '.';p++);
	if(*p == '\0'){
		return 0;
	}
	*p = '\0';
	sub_version = atoi(q);

	p++;
	beta_version = 0;
	for(q = p; *p != '\0' && !isspace(*p) ;p++);
	if(*p == '\0'){
		minor_version = atoi(q);
	}
	else{
		*p = '\0';
		minor_version = atoi(q);

		p++;
		for(; *p != '\0' && !isdigit(*p) ;p++);

		beta_version = atoi(p);
	}

	return (major_version << 24) | (sub_version << 16) |
		   (minor_version <<  8) | (beta_version);

}

unsigned long GetWWWCVersion(HWND hwnd)
{
	char szVersion[32];

	/*
	 * "1.0.3 b1"
	 *  擪major_version, sub_version, minor_version, beta_version
	 *  ꂼ̃o[WPoCgpackĕԂB
	 */
	SendMessage(hwnd, WM_GETVERSION, 0, (LPARAM)szVersion);
	return ParseWWWCVersion(szVersion);
}

/*
 * gpĂWWWC̃o[WƓ̃o[Wr
 * gpĂWWWC̕VƂ 1
 *                       Ƃ   0
 *                       ÂƂ  -1Ԃ
 *
 */
int CmpVersion(unsigned long Version,int major, int sub, int minor, int beta)
{
	unsigned long wwwc_version;
	unsigned long cmp_version;
	int wwwc_beta;

	wwwc_version = (Version >> 8);
	cmp_version  = (major << 16) | (sub << 8) | minor;
	if(wwwc_version > cmp_version){
		return 1;
	}
	else if(wwwc_version < cmp_version){
		return -1;
	}

	wwwc_beta = Version & 0xff;
	if(wwwc_beta == beta){
		return 0;
	}

	/* o[ẂA0ŐV */
	if(wwwc_beta == 0){
		return 1;
	}
	else if(beta == 0){
		return -1;
	}

	if(wwwc_beta > beta){
		return 1;
	}
	else if(wwwc_beta < beta){
		return -1;
	}
	return 0;
}


void DeleteReturn(char *buf)
{
	if(buf){
		for(;*buf;buf++){
			if(*buf == '\r'|| *buf == '\n' || *buf == '\t'){
				*buf = ' ';
			}
		}
	} 
}

